// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/LoadCarrierWithFillingLevel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__TRAITS_HPP_

#include "rc_reason_msgs/msg/detail/load_carrier_with_filling_level__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__traits.hpp"
// Member 'rim_thickness'
// Member 'rim_ledge'
#include "rc_reason_msgs/msg/detail/rectangle__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"
// Member 'overall_filling_level'
// Member 'cells_filling_levels'
#include "rc_reason_msgs/msg/detail/cell_filling_level__traits.hpp"
// Member 'filling_level_cell_count'
#include "rc_reason_msgs/msg/detail/grid_size__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rc_reason_msgs::msg::LoadCarrierWithFillingLevel & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: outer_dimensions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "outer_dimensions:\n";
    to_yaml(msg.outer_dimensions, out, indentation + 2);
  }

  // member: inner_dimensions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "inner_dimensions:\n";
    to_yaml(msg.inner_dimensions, out, indentation + 2);
  }

  // member: rim_thickness
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_thickness:\n";
    to_yaml(msg.rim_thickness, out, indentation + 2);
  }

  // member: rim_step_height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_step_height: ";
    value_to_yaml(msg.rim_step_height, out);
    out << "\n";
  }

  // member: rim_ledge
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rim_ledge:\n";
    to_yaml(msg.rim_ledge, out, indentation + 2);
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_yaml(msg.pose, out, indentation + 2);
  }

  // member: overfilled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overfilled: ";
    value_to_yaml(msg.overfilled, out);
    out << "\n";
  }

  // member: overall_filling_level
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overall_filling_level:\n";
    to_yaml(msg.overall_filling_level, out, indentation + 2);
  }

  // member: cells_filling_levels
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cells_filling_levels.size() == 0) {
      out << "cells_filling_levels: []\n";
    } else {
      out << "cells_filling_levels:\n";
      for (auto item : msg.cells_filling_levels) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: filling_level_cell_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filling_level_cell_count:\n";
    to_yaml(msg.filling_level_cell_count, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rc_reason_msgs::msg::LoadCarrierWithFillingLevel & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rc_reason_msgs::msg::LoadCarrierWithFillingLevel>()
{
  return "rc_reason_msgs::msg::LoadCarrierWithFillingLevel";
}

template<>
inline const char * name<rc_reason_msgs::msg::LoadCarrierWithFillingLevel>()
{
  return "rc_reason_msgs/msg/LoadCarrierWithFillingLevel";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::LoadCarrierWithFillingLevel>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::LoadCarrierWithFillingLevel>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::LoadCarrierWithFillingLevel>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__TRAITS_HPP_
