// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/DetectItems.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__TRAITS_HPP_

#include "rc_reason_msgs/srv/detail/detect_items__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__traits.hpp"
// Member 'item_models'
#include "rc_reason_msgs/msg/detail/item_model__traits.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rc_reason_msgs::srv::DetectItems_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: region_of_interest_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "region_of_interest_id: ";
    value_to_yaml(msg.region_of_interest_id, out);
    out << "\n";
  }

  // member: load_carrier_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_id: ";
    value_to_yaml(msg.load_carrier_id, out);
    out << "\n";
  }

  // member: load_carrier_compartment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_compartment:\n";
    to_yaml(msg.load_carrier_compartment, out, indentation + 2);
  }

  // member: item_models
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.item_models.size() == 0) {
      out << "item_models: []\n";
    } else {
      out << "item_models:\n";
      for (auto item : msg.item_models) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_pose:\n";
    to_yaml(msg.robot_pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rc_reason_msgs::srv::DetectItems_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectItems_Request>()
{
  return "rc_reason_msgs::srv::DetectItems_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectItems_Request>()
{
  return "rc_reason_msgs/srv/DetectItems_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectItems_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectItems_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::DetectItems_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'items'
#include "rc_reason_msgs/msg/detail/item__traits.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rc_reason_msgs::srv::DetectItems_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: items
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.items.size() == 0) {
      out << "items: []\n";
    } else {
      out << "items:\n";
      for (auto item : msg.items) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: load_carriers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []\n";
    } else {
      out << "load_carriers:\n";
      for (auto item : msg.load_carriers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rc_reason_msgs::srv::DetectItems_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectItems_Response>()
{
  return "rc_reason_msgs::srv::DetectItems_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectItems_Response>()
{
  return "rc_reason_msgs/srv/DetectItems_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectItems_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectItems_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::DetectItems_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectItems>()
{
  return "rc_reason_msgs::srv::DetectItems";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectItems>()
{
  return "rc_reason_msgs/srv/DetectItems";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectItems>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::DetectItems_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::DetectItems_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectItems>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::DetectItems_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::DetectItems_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::DetectItems>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::DetectItems_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::DetectItems_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__TRAITS_HPP_
