// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/HandEyeCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__TRAITS_HPP_

#include "rc_reason_msgs/srv/detail/hand_eye_calibration__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rc_reason_msgs::srv::HandEyeCalibration_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rc_reason_msgs::srv::HandEyeCalibration_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibration_Request>()
{
  return "rc_reason_msgs::srv::HandEyeCalibration_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibration_Request>()
{
  return "rc_reason_msgs/srv/HandEyeCalibration_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibration_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibration_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rc_reason_msgs::srv::HandEyeCalibration_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rc_reason_msgs::srv::HandEyeCalibration_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    value_to_yaml(msg.message, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_yaml(msg.pose, out, indentation + 2);
  }

  // member: error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error: ";
    value_to_yaml(msg.error, out);
    out << "\n";
  }

  // member: translation_error_meter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "translation_error_meter: ";
    value_to_yaml(msg.translation_error_meter, out);
    out << "\n";
  }

  // member: rotation_error_degree
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rotation_error_degree: ";
    value_to_yaml(msg.rotation_error_degree, out);
    out << "\n";
  }

  // member: robot_mounted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_mounted: ";
    value_to_yaml(msg.robot_mounted, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rc_reason_msgs::srv::HandEyeCalibration_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibration_Response>()
{
  return "rc_reason_msgs::srv::HandEyeCalibration_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibration_Response>()
{
  return "rc_reason_msgs/srv/HandEyeCalibration_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibration_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibration_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::HandEyeCalibration_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::HandEyeCalibration>()
{
  return "rc_reason_msgs::srv::HandEyeCalibration";
}

template<>
inline const char * name<rc_reason_msgs::srv::HandEyeCalibration>()
{
  return "rc_reason_msgs/srv/HandEyeCalibration";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::HandEyeCalibration>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::HandEyeCalibration_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::HandEyeCalibration_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::HandEyeCalibration>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::HandEyeCalibration_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::HandEyeCalibration_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::HandEyeCalibration>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::HandEyeCalibration_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::HandEyeCalibration_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__TRAITS_HPP_
